-- DSER-37408 Make the CPS be able to get the MIME type from RMS


-- Reference table for the FORMAT enumeration
create table if not exists format (
                                      id smallint not null,
                                      name varchar(50) not null,
    mime_type varchar(255) not null,
    description varchar(255) not null,
    primary key (id)
    );

COMMENT ON TABLE format IS 'Format is use to specify the format of content stored in SegmentData';

insert into format
(id, name, mime_type, description)
values (0, 'RULE_JSON', 'application/json', 'MIME type for DRE rule content ')
    on conflict do nothing;

insert into format
(id, name, mime_type, description)
values (1, 'BINARY', 'application/octet-stream','MIME type for binary content ')
    on conflict do nothing;

insert into format
(id, name, mime_type, description)
values (2, 'TEXT', 'text/plain','MIME type for text content ')
    on conflict do nothing;

insert into format
(id, name, mime_type, description)
values (3, 'ZIP', 'application/zip','MIME type for zipped content ')
    on conflict do nothing;

ALTER TABLE if exists segment_type
    ADD FOREIGN KEY (format) REFERENCES Format(id);