-- DSER-38106 New template parameters table
-- Creating a new template parameters table to store params that will be passed via assignments

-- template_param can be null since you could have an assignment for a segment with this mustache processor and not specify any template_params
-- but we can still make an entry in the new table to signify there is an assignment which references a mustache segment with null template_params
CREATE TABLE IF NOT EXISTS template_parameter (
    template_param_id bigserial NOT NULL,
    assignment_id bigint NOT NULL,
    template_param text,
    created_dt bigint,
    updated_dt bigint,
    PRIMARY KEY (template_param_id),
    FOREIGN KEY (assignment_id) REFERENCES assignment(assignment_id) ON DELETE CASCADE
    );