-- DSER-40457 Add reference table for Distribution field

CREATE TABLE IF NOT EXISTS distribution (
    id SMALLINT NOT NULL,
    name VARCHAR(50) NOT NULL,
    description VARCHAR(255) NOT NULL,
    PRIMARY KEY (id)
    );

-- inserting the data into the table

INSERT INTO distribution
(id, name, description)
VALUES (0, 'UNIVERSAL', 'Delivering content which is not related to any specific distribution')
ON conflict do nothing;

INSERT INTO distribution
(id, name, description)
VALUES (1, 'AMAZON_LINUX', 'Delivering content targeted to AMAZON_LINUX type sensors')
ON conflict do nothing;

INSERT INTO distribution
(id, name, description)
VALUES (2, 'RHEL_CENTOS', 'Delivering content targeted to RHEL_CENTOS type sensors')
ON conflict do nothing;

INSERT INTO distribution
(id, name, description)
VALUES (3, 'UBUNTU', 'Delivering content targeted to UBUNTU type sensors')
ON conflict do nothing;

INSERT INTO distribution
(id, name, description)
VALUES (4, 'SUSE', 'Delivering content targeted to SUSE type sensors')
ON conflict do nothing;

INSERT INTO distribution
(id, name, description)
VALUES (5, 'AMAZON', 'Delivering content targeted to AMAZON type sensors')
ON conflict do nothing;

INSERT INTO distribution
(id, name, description)
VALUES (6, 'RHEL', 'Delivering content targeted to RHEL type sensors')
ON conflict do nothing;

INSERT INTO distribution
(id, name, description)
VALUES (7, 'CENTOS', 'Delivering content targeted to CENTOS type sensors')
ON conflict do nothing;


-- Creating foreign keys in segment_data and assignment table
ALTER TABLE segment_data
ADD CONSTRAINT segment_data_distribution_fkey FOREIGN KEY (distribution) REFERENCES distribution (id);

ALTER TABLE assignment
ADD CONSTRAINT assignment_distribution_fkey FOREIGN KEY (distribution) REFERENCES distribution (id);


-- update segment_types TEST, SENSOR_DRE and SENSOR_GENERAL to support all the distributions.
UPDATE segment_type
SET    distributions = 'UNIVERSAL,AMAZON_LINUX,RHEL_CENTOS,UBUNTU,SUSE,AMAZON,RHEL,CENTOS'
WHERE  name = 'TEST';

UPDATE segment_type
SET    distributions = 'UNIVERSAL,AMAZON_LINUX,RHEL_CENTOS,UBUNTU,SUSE,AMAZON,RHEL,CENTOS'
WHERE  name = 'SENSOR_DRE';

UPDATE segment_type
SET    distributions = 'UNIVERSAL,AMAZON_LINUX,RHEL_CENTOS,UBUNTU,SUSE,AMAZON,RHEL,CENTOS'
WHERE  name = 'SENSOR_GENERAL';