-- DSER-42356 Add reference table for Architecture field

CREATE TABLE IF NOT EXISTS architecture (
    id SMALLINT NOT NULL,
    name VARCHAR(50) NOT NULL,
    description VARCHAR(255) NOT NULL,
    PRIMARY KEY (id)
    );

-- inserting the data into the table

INSERT INTO architecture
(id, name, description)
VALUES (0, 'UNIVERSAL', 'Delivering content which is not related to any specific architecture')
ON conflict do nothing;

INSERT INTO architecture
(id, name, description)
VALUES (1, 'BIT32', 'Delivering content targeted to BIT32 architecture')
ON conflict do nothing;

INSERT INTO architecture
(id, name, description)
VALUES (2, 'BIT64', 'Delivering content targeted to BIT64 architecture')
ON conflict do nothing;

INSERT INTO architecture
(id, name, description)
VALUES (3, 'ARM64', 'Delivering content targeted to ARM64 architecture')
ON conflict do nothing;


-- Creating foreign keys in segment_data and assignment table
ALTER TABLE segment_data DROP CONSTRAINT IF EXISTS segment_data_architecture_fkey;
ALTER TABLE segment_data ADD CONSTRAINT segment_data_architecture_fkey FOREIGN KEY (architecture) REFERENCES architecture (id);

ALTER TABLE assignment DROP CONSTRAINT IF EXISTS assignment_architecture_fkey;
ALTER TABLE assignment ADD CONSTRAINT assignment_architecture_fkey FOREIGN KEY (architecture) REFERENCES architecture (id);


-- update segment_types TEST, SENSOR_DRE, SENSOR_GENERAL, and SENSOR_KITS to support all the architectures.
UPDATE segment_type
SET    architectures = 'UNIVERSAL,BIT32,BIT64,ARM64'
WHERE  name = 'TEST';

UPDATE segment_type
SET    architectures = 'UNIVERSAL,BIT32,BIT64,ARM64'
WHERE  name = 'SENSOR_DRE';

UPDATE segment_type
SET    architectures = 'UNIVERSAL,BIT32,BIT64,ARM64'
WHERE  name = 'SENSOR_GENERAL';

UPDATE segment_type
SET    architectures = 'UNIVERSAL,BIT32,BIT64,ARM64'
WHERE  name = 'SENSOR_KITS';