-- Update segment_types support GROUP scope.

-- Added a inner select query to concat GROUP scope to whatever
-- existing scope was there for each segment_type excluding
-- UDS_BUNDLE, UDS_PIPELINE and SENSOR_KITS segment_types.


UPDATE segment_type A
SET    assign_scopes = B.new_assign_scope
FROM   (
          SELECT name, assign_scopes, concat(assign_scopes,',','GROUP') AS new_assign_scope
          FROM   segment_type
          WHERE  name NOT IN ('UDS_BUNDLE', 'UDS_PIPELINE', 'SENSOR_KITS')
       )  B
WHERE A.name = B.name
AND   A.assign_scopes NOT LIKE '%,GROUP';

